# coding: utf-8

# flake8: noqa
"""
    Cloudbeds API

    <p>Welcome to the documentation for <strong>Cloudbeds API Version v2</strong>! If you are looking to learn how to use the Cloudbeds API to access guest information, reservations, or similar data for your Cloudbeds customers, then you've come to the right place.</p><p>In this document you will find all the API methods we provide along with explanations for parameters and response examples.</p><p>If you have questions about different implementation steps (e.g. how to implement OAuth 2.0), please refer to our <a href='https://integrations.cloudbeds.com/hc/en-us'>Integrations Portal</a>.</p><p>Be sure to <a href='https://go.pardot.com/l/308041/2018-07-24/qb2lg'>subscribe</a> to the monthly Cloudbeds API announcement mailing list to receive information on new additions and improvements to the Cloudbeds API and related developer tools.</p><p><strong>Endpoint:</strong> https://api.cloudbeds.com/{method}</p><p><strong>HTTPS:</strong> Our API requires HTTPS. We'll respond with an appropriate error if you're not using it.</p><p><strong>Request Format:</strong> HTTP GET, POST and PUT (Content-Type: application/x-www-form-urlencoded)</p><p><strong>Response Format:</strong> JSON</p><p><strong>Response Header:</strong> X-Request-ID is added to response headers in all calls to help accelerate support and troubleshooting.</p><p><strong><a href='https://integrations.cloudbeds.com/hc/en-us/articles/14104678058267-API-Documentation#postman-collection'><img src='https://run.pstmn.io/button.svg' alt='Run in Postman'></a></strong> use this link to access our Public collection in Postman.</p>

    The version of the OpenAPI document: v2
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


# import models into model package
from cloudbeds_pms.models.bad_request_error_item_schema import BadRequestErrorItemSchema
from cloudbeds_pms.models.bad_request_response_schema import BadRequestResponseSchema
from cloudbeds_pms.models.bad_request_response_schema_errors import BadRequestResponseSchemaErrors
from cloudbeds_pms.models.body_dynamic_filter_schema import BodyDynamicFilterSchema
from cloudbeds_pms.models.body_dynamic_filter_schema_filters import BodyDynamicFilterSchemaFilters
from cloudbeds_pms.models.cursor_pagination_schema import CursorPaginationSchema
from cloudbeds_pms.models.direction_enum_schema import DirectionEnumSchema
from cloudbeds_pms.models.door_lock_key_create_request_schema import DoorLockKeyCreateRequestSchema
from cloudbeds_pms.models.door_lock_key_failed_to_generate_response_schema import DoorLockKeyFailedToGenerateResponseSchema
from cloudbeds_pms.models.door_lock_key_list_request_schema import DoorLockKeyListRequestSchema
from cloudbeds_pms.models.door_lock_key_list_response_schema import DoorLockKeyListResponseSchema
from cloudbeds_pms.models.door_lock_key_response_schema import DoorLockKeyResponseSchema
from cloudbeds_pms.models.door_lock_key_update_request_schema import DoorLockKeyUpdateRequestSchema
from cloudbeds_pms.models.door_lock_settings_common_room_request_schema import DoorLockSettingsCommonRoomRequestSchema
from cloudbeds_pms.models.door_lock_settings_common_room_response_schema import DoorLockSettingsCommonRoomResponseSchema
from cloudbeds_pms.models.door_lock_settings_create_request_schema import DoorLockSettingsCreateRequestSchema
from cloudbeds_pms.models.door_lock_settings_encoder_request_schema import DoorLockSettingsEncoderRequestSchema
from cloudbeds_pms.models.door_lock_settings_encoder_response_schema import DoorLockSettingsEncoderResponseSchema
from cloudbeds_pms.models.door_lock_settings_key_type_request_schema import DoorLockSettingsKeyTypeRequestSchema
from cloudbeds_pms.models.door_lock_settings_key_type_response_schema import DoorLockSettingsKeyTypeResponseSchema
from cloudbeds_pms.models.door_lock_settings_response_schema import DoorLockSettingsResponseSchema
from cloudbeds_pms.models.dynamic_filter_field_schema import DynamicFilterFieldSchema
from cloudbeds_pms.models.dynamic_filter_field_schema_value import DynamicFilterFieldSchemaValue
from cloudbeds_pms.models.dynamic_filter_schema import DynamicFilterSchema
from cloudbeds_pms.models.dynamic_filter_schema_and_inner import DynamicFilterSchemaAndInner
from cloudbeds_pms.models.feature_enum import FeatureEnum
from cloudbeds_pms.models.filter_operator_enum_schema import FilterOperatorEnumSchema
from cloudbeds_pms.models.forbidden_response_schema import ForbiddenResponseSchema
from cloudbeds_pms.models.group_create_request_schema import GroupCreateRequestSchema
from cloudbeds_pms.models.group_delete_request_schema import GroupDeleteRequestSchema
from cloudbeds_pms.models.group_disable_request_schema import GroupDisableRequestSchema
from cloudbeds_pms.models.group_enable_request_schema import GroupEnableRequestSchema
from cloudbeds_pms.models.group_list_response_schema import GroupListResponseSchema
from cloudbeds_pms.models.group_response_schema import GroupResponseSchema
from cloudbeds_pms.models.group_single_request_schema import GroupSingleRequestSchema
from cloudbeds_pms.models.group_update_request_schema import GroupUpdateRequestSchema
from cloudbeds_pms.models.import_failed_to_create_import_task_schema import ImportFailedToCreateImportTaskSchema
from cloudbeds_pms.models.import_failed_to_pre_process_response_schema import ImportFailedToPreProcessResponseSchema
from cloudbeds_pms.models.import_failed_to_process_csv_response_schema import ImportFailedToProcessCsvResponseSchema
from cloudbeds_pms.models.import_task_create_request_schema import ImportTaskCreateRequestSchema
from cloudbeds_pms.models.import_task_get_record_list_request_schema import ImportTaskGetRecordListRequestSchema
from cloudbeds_pms.models.import_task_get_response_schema import ImportTaskGetResponseSchema
from cloudbeds_pms.models.import_task_list_failed_response_schema import ImportTaskListFailedResponseSchema
from cloudbeds_pms.models.import_task_list_request_schema import ImportTaskListRequestSchema
from cloudbeds_pms.models.import_task_list_response_schema import ImportTaskListResponseSchema
from cloudbeds_pms.models.import_task_record_get_response_schema import ImportTaskRecordGetResponseSchema
from cloudbeds_pms.models.import_task_record_list_response_schema import ImportTaskRecordListResponseSchema
from cloudbeds_pms.models.import_task_response_schema import ImportTaskResponseSchema
from cloudbeds_pms.models.inspection_item_schema import InspectionItemSchema
from cloudbeds_pms.models.inspection_list_request_schema import InspectionListRequestSchema
from cloudbeds_pms.models.inspection_list_response_schema import InspectionListResponseSchema
from cloudbeds_pms.models.internal_server_error_response_schema import InternalServerErrorResponseSchema
from cloudbeds_pms.models.limit_offset_pagination_schema import LimitOffsetPaginationSchema
from cloudbeds_pms.models.not_found_response_schema import NotFoundResponseSchema
from cloudbeds_pms.models.query_parameter_dynamic_filter_schema import QueryParameterDynamicFilterSchema
from cloudbeds_pms.models.query_parameter_dynamic_filter_schema_filters import QueryParameterDynamicFilterSchemaFilters
from cloudbeds_pms.models.query_parameter_sort_schema import QueryParameterSortSchema
from cloudbeds_pms.models.segment_create_request_schema import SegmentCreateRequestSchema
from cloudbeds_pms.models.segment_delete_request_schema import SegmentDeleteRequestSchema
from cloudbeds_pms.models.segment_disable_request_schema import SegmentDisableRequestSchema
from cloudbeds_pms.models.segment_enable_request_schema import SegmentEnableRequestSchema
from cloudbeds_pms.models.segment_list_request_schema import SegmentListRequestSchema
from cloudbeds_pms.models.segment_list_reservations_request_schema import SegmentListReservationsRequestSchema
from cloudbeds_pms.models.segment_list_reservations_response_schema import SegmentListReservationsResponseSchema
from cloudbeds_pms.models.segment_list_response_schema import SegmentListResponseSchema
from cloudbeds_pms.models.segment_response_schema import SegmentResponseSchema
from cloudbeds_pms.models.segment_single_request_schema import SegmentSingleRequestSchema
from cloudbeds_pms.models.segment_update_request_schema import SegmentUpdateRequestSchema
from cloudbeds_pms.models.sort_field_schema import SortFieldSchema
from cloudbeds_pms.models.sort_schema import SortSchema
