# coding: utf-8

"""
    Cloudbeds API

    <p>Welcome to the documentation for <strong>Cloudbeds API Version v2</strong>! If you are looking to learn how to use the Cloudbeds API to access guest information, reservations, or similar data for your Cloudbeds customers, then you've come to the right place.</p><p>In this document you will find all the API methods we provide along with explanations for parameters and response examples.</p><p>If you have questions about different implementation steps (e.g. how to implement OAuth 2.0), please refer to our <a href='https://integrations.cloudbeds.com/hc/en-us'>Integrations Portal</a>.</p><p>Be sure to <a href='https://go.pardot.com/l/308041/2018-07-24/qb2lg'>subscribe</a> to the monthly Cloudbeds API announcement mailing list to receive information on new additions and improvements to the Cloudbeds API and related developer tools.</p><p><strong>Endpoint:</strong> https://api.cloudbeds.com/{method}</p><p><strong>HTTPS:</strong> Our API requires HTTPS. We'll respond with an appropriate error if you're not using it.</p><p><strong>Request Format:</strong> HTTP GET, POST and PUT (Content-Type: application/x-www-form-urlencoded)</p><p><strong>Response Format:</strong> JSON</p><p><strong>Response Header:</strong> X-Request-ID is added to response headers in all calls to help accelerate support and troubleshooting.</p><p><strong><a href='https://integrations.cloudbeds.com/hc/en-us/articles/14104678058267-API-Documentation#postman-collection'><img src='https://run.pstmn.io/button.svg' alt='Run in Postman'></a></strong> use this link to access our Public collection in Postman.</p>

    The version of the OpenAPI document: v2
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List
from cloudbeds_pms.models.door_lock_settings_common_room_response_schema import DoorLockSettingsCommonRoomResponseSchema
from cloudbeds_pms.models.door_lock_settings_encoder_response_schema import DoorLockSettingsEncoderResponseSchema
from cloudbeds_pms.models.door_lock_settings_key_type_response_schema import DoorLockSettingsKeyTypeResponseSchema
from typing import Optional, Set
from typing_extensions import Self

class DoorLockSettingsResponseSchema(BaseModel):
    """
    DoorLockSettingsResponseSchema
    """ # noqa: E501
    key_types: List[DoorLockSettingsKeyTypeResponseSchema] = Field(description="$keyTypes", alias="keyTypes")
    encoders: List[DoorLockSettingsEncoderResponseSchema] = Field(description="$encoders")
    common_rooms: List[DoorLockSettingsCommonRoomResponseSchema] = Field(description="$commonRooms", alias="commonRooms")
    __properties: ClassVar[List[str]] = ["keyTypes", "encoders", "commonRooms"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of DoorLockSettingsResponseSchema from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in key_types (list)
        _items = []
        if self.key_types:
            for _item_key_types in self.key_types:
                if _item_key_types:
                    _items.append(_item_key_types.to_dict())
            _dict['keyTypes'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in encoders (list)
        _items = []
        if self.encoders:
            for _item_encoders in self.encoders:
                if _item_encoders:
                    _items.append(_item_encoders.to_dict())
            _dict['encoders'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in common_rooms (list)
        _items = []
        if self.common_rooms:
            for _item_common_rooms in self.common_rooms:
                if _item_common_rooms:
                    _items.append(_item_common_rooms.to_dict())
            _dict['commonRooms'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of DoorLockSettingsResponseSchema from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "keyTypes": [DoorLockSettingsKeyTypeResponseSchema.from_dict(_item) for _item in obj["keyTypes"]] if obj.get("keyTypes") is not None else None,
            "encoders": [DoorLockSettingsEncoderResponseSchema.from_dict(_item) for _item in obj["encoders"]] if obj.get("encoders") is not None else None,
            "commonRooms": [DoorLockSettingsCommonRoomResponseSchema.from_dict(_item) for _item in obj["commonRooms"]] if obj.get("commonRooms") is not None else None
        })
        return _obj


